
var pattern = null;

function pageLoad()
{
	pattern = MindFusion.Diagramming.AnchorPattern.fromId("LeftInRightOut");
}

function onDiagramNodeCreated(diagram, e)
{
	e.getNode().setAnchorPattern(pattern);

	// Place the box within the grid
	var bounds = e.getNode().getBounds();
	var topLeft = new MindFusion.Drawing.Point(bounds.x, bounds.y);

	var diagram = $find("diagramView");
	var grid = diagram.getLaneGrid();

	var cellBoundsReciever = {};
	if (!grid.getCellFromPoint(topLeft, cellBoundsReciever))
		return;
	var cellBounds = cellBoundsReciever.cellBounds;

	var pixel = 1;

	bounds.y = cellBounds.y + pixel;
	bounds.height = cellBounds.height - 2 * pixel;
	e.getNode().setBounds(bounds);
}

function onDiagramLinkCreated(diagram, e)
{
	fixArrow(e.getLink());
}

function fixArrow(a)
{
	var originBounds = a.getOrigin().getBounds();
	var destBounds = a.getDestination().getBounds();

	if (originBounds.right() < destBounds.left())
	{
		a.setPoints([
			new MindFusion.Drawing.Point(originBounds.right(), originBounds.y + originBounds.height / 2),
			new MindFusion.Drawing.Point(destBounds.x, originBounds.y + originBounds.height / 2),
			new MindFusion.Drawing.Point(destBounds.x, destBounds.y)
		]);
	}
	else
	{
		a.setPoints([
			new MindFusion.Drawing.Point(originBounds.right(), originBounds.y + originBounds.height / 2),
			new MindFusion.Drawing.Point(originBounds.right() + 2, originBounds.y + originBounds.height / 2),
			new MindFusion.Drawing.Point(originBounds.right() + 2, originBounds.y + originBounds.height / 2 + 4),
			new MindFusion.Drawing.Point(destBounds.x, originBounds.y + originBounds.height / 2 + 4),
			new MindFusion.Drawing.Point(destBounds.x, destBounds.y)
		]);
	}
}

function onDiagramNodeModified(diagram, e)
{
	// Place the box within the grid
	var bounds = e.getNode().getBounds();
	var topLeft = new MindFusion.Drawing.Point(bounds.x, bounds.y + bounds.height / 2);

	var diagram = $find("diagramView");
	var grid = diagram.getLaneGrid();

	var cellBounds = MindFusion.Drawing.Rect.empty;
	var cellBoundsReciever = {};
	if (!grid.getCellFromPoint(topLeft, cellBoundsReciever))
		return;
	var cellBounds = cellBoundsReciever.cellBounds;

	var pixel = 1;

	bounds.y = cellBounds.y + pixel;
	bounds.height = cellBounds.height - 2 * pixel;
	e.getNode().setBounds(bounds);

	// Fix links
	for (var i = 0; i < e.getNode().getIncomingLinks().length; i++)
		fixArrow(e.getNode().getIncomingLinks()[i]);
	for (var i = 0; i < e.getNode().getOutgoingLinks().length; i++)
		fixArrow(e.getNode().getOutgoingLinks()[i]);
}